#include 'minigui.ch'
#include 'hbsqlit3.ch'
#include 'common.ch'

static aData := {}, aGrid := {}, mRecPtr := 0, mRecCount := 0

PROCEDURE ExpMst
   private lAddmode := .f.

   if isWindowDefined(frmExp)
      return nil
   endif
   
   DEFINE WINDOW frmExp            ;
      AT 0,0               ;
      WIDTH 635            ;
      HEIGHT 460            ;
      TITLE 'Expense Head Setup'   ;
      CHILD ;
      FONT 'ARIAL' SIZE 9         ;
      ON INIT (ReQuery(), DeactivateEdit(), RefreshData() )

      DEFINE TOOLBAR ToolBar_1 BUTTONSIZE 50,30 FLAT RIGHTTEXT BORDER

      BUTTON btnFirst       ;
         CAPTION '&Top' ;
         picture "HP_TOP" ;
         ACTION GoTop()

      BUTTON btnPrev    ;
         CAPTION '&Prev'    ;
         PICTURE "HP_BACK" ;
         ACTION RecSkip(-1)

      BUTTON btnNext   ;
         CAPTION '&Next'    ;
         PICTURE "HP_NEXT" ;
         ACTION RecSkip(1)

      BUTTON btnLast       ;
         CAPTION '&Last'    ;
         PICTURE "HP_END" ;
         ACTION GoBottom()

      BUTTON btnAdd       ;
         CAPTION '&Add'    ;
         PICTURE "MINIGUI_EDIT_ADD" ;
         ACTION (lAddMode := .T., AddRec())

      BUTTON btnModify       ;
         CAPTION '&Modify'    ;
         PICTURE "MINIGUI_EDIT_EDIT" ;
         ACTION ActivateEdit()

      BUTTON btnDelete    ;
         CAPTION '&Delete'   ;
         PICTURE "MINIGUI_EDIT_DELETE" ;
         ACTION DeleteRec()
         

      END TOOLBAR

      @ 56, 10 TEXTBOX txtSearch ;
         width 190 ;
         height 24 ;
         on change SearchData()
         
      @ 86,10 GRID Grid_1            ;
         WIDTH 190              ;
         HEIGHT 330             ;
         HEADERS { 'Expense Heads'}   ;
         WIDTHS { 180 }         ;
         ITEMS aGrid ;
         ON CHANGE {|| mRecPtr := frmExp.grid_1.value, RefreshData(mRecptr)} ;
         ON DBLCLICK ActivateEdit()


      @ 56,210 FRAME FRAME_1 ;
         WIDTH 400      ;
         HEIGHT 360


      @ 66 , 220 LABEL LABEL_1 ;
         VALUE 'Exp. Head:' ;
         WIDTH 80

      @ 66 , 290 TEXTBOX txtExpnm ;
         width 200 ;
         MAXLENGTH 40

      @ 96 , 220 LABEL LABEL_2 ;
         VALUE 'Amount:' ;
         WIDTH 80
         
      @ 96 , 290 TEXTBOX txtAmt ;
         NUMERIC INPUTMASK "999,999,999.99"
         
      @ 126 , 220 LABEL LABEL_3 ;
         VALUE 'Remarks:' ;
         WIDTH 80
         
      @ 126 , 290 TEXTBOX txtRem ;
         width 200 ;
         MAXLENGTH 80 



      @ 376,320 BUTTON cmdSave ;
         CAPTION '&Save' ;
         PICTURE "MINIGUI_EDIT_OK" LEFT ;
         ACTION SaveRec()

      @ 376,425 BUTTON cmdCancel ;
         CAPTION '&Cancel' ;
         PICTURE "MINIGUI_EDIT_CANCEL"  LEFT ;
         ACTION CancelRec()

   END WINDOW
   ON KEY F1 of frmExp ACTION HELP(4)
   

   frmExp.Grid_1.SetFocus
   CENTER WINDOW frmExp
   ACTIVATE WINDOW frmExp

   RETURN
   

static Function ReQuery()
	aData := {}
	aGrid := {}
	aData := SQLITE_QUERY(Db, "select expid, expnm, amt, rem from exp order by expnm")
	aeval(aData, {|x| aadd(aGrid, {x[2]})})
	mRecCount := len(aData)
	frmExp.grid_1.deleteallitems()
	aeval(aGrid, {|x| frmExp.grid_1.additem(x)})
	if mRecPtr = 0 .and. mRecCount > 0
		mRecPtr := 1
		frmExp.grid_1.value := mRecPtr
	endif
   return nil
   

static function GoTop()
	if mRecCount = 0
		return nil
	endif
	mRecPtr := 1
	frmExp.grid_1.value := mRecPtr
	return nil
	
	

static function RecSkip(n)
	if mRecCount = 0
		return nil
	endif
	if mRecPtr+n >= 1 .and. mRecPtr+n <= mRecCount
		mRecPtr += n
	else
		mRecPtr := if(n > 0, mRecCount, 1)
	endif
	frmExp.grid_1.value := mRecPtr
	return nil
		

static function GoBottom()
	if mRecCount = 0
		return nil
	endif
	mRecPtr := mRecCount
	frmExp.grid_1.value := mRecPtr
	return nil
	

   
static function SearchData()
	local s, tmp
	s = upper(alltrim(frmExp.txtSearch.value))
	tmp := ascan(aGrid, {|x| left(upper(alltrim(x[1])), len(s)) = s})
	if tmp > 0
		frmExp.Grid_1.value := tmp
	endif
	return nil


static PROCEDURE DeactivateEdit
   frmExp.Grid_1.Enabled  := .T.
   frmExp.txtSearch.Enabled := .t.
   frmExp.txtExpnm.enabled := .f.
   frmExp.txtAmt.enabled := .f.
   frmExp.txtRem.enabled := .f.
   

   frmExp.cmdSave.Enabled      := .F.
   frmExp.cmdCancel.Enabled      := .F.
   frmExp.ToolBar_1.Enabled      := .T.
   frmExp.Grid_1.SetFocus
   RETURN


static PROCEDURE ActivateEdit
   frmExp.Grid_1.Enabled  := .f.
   frmExp.txtSearch.Enabled := .f.
   frmExp.txtExpnm.enabled := .t.
   frmExp.txtAmt.enabled := .t.
   frmExp.txtRem.enabled := .t.

   frmExp.cmdSave.Enabled      := .t.
   frmExp.cmdCancel.Enabled      := .t.
   frmExp.ToolBar_1.Enabled      := .f.
   frmExp.txtExpnm.SetFocus
   RETURN


static PROCEDURE CancelRec()
   DeactivateEdit()
   RefreshData()
   lAddmode := .f.
   RETURN


static PROCEDURE SaveRec()
   local mOldrec, mExpid, mExpnm, mAmt, mRem
   
   mExpnm := frmExp.txtExpnm.value
   mAmt := frmExp.txtAmt.value
   mRem := frmExp.txtRem.value
   
   if empty(mExpnm)
      msgbox("Expense Head Name cannot be blank!", thiswindow.title); frmExp.txtExpnm.setfocus(); return
   endif
   
   If lAddmode
   	if !miscsql(db, "INSERT INTO EXP (EXPID, EXPNM, AMT, REM) VALUES " + ;
   		" (NULL, '"+mExpnm+"', "+str(mAmt, 12, 2)+", '"+mRem+"');")
   		return
   	endif
   	lAddmode = .f.
   else
		mExpid := aData[mRecPtr, 1]   
   	if !miscsql(db, "UPDATE EXP SET EXPNM = '"+mExpnm+"', AMT = "+str(mAmt, 12, 2)+ ;
   		", REM = '"+mRem+"' WHERE EXPID = "+STR(mExpid)+";")
   		Return
   	endif
   endif
   Requery()
   mRecPtr = ascan(aData, {|x| upper(alltrim(x[2])) == alltrim(upper(mExpnm))})
   frmExp.grid_1.value := mRecPtr
   DeactivateEdit()
   RETURN



static PROCEDURE AddRec()
   frmExp.txtExpnm.value := ''
   frmExp.txtAmt.value := 0.00
   frmExp.txtRem.value := ''
   ActivateEdit()
   RETURN


static PROCEDURE RefreshData(nRec)
	default nRec to mRecPtr
   frmExp.txtExpnm.value := iif(nRec > 0, aData[nRec, 2], '')
   frmExp.txtAmt.value := iif(nRec > 0, aData[nRec, 3], 0.00)
   frmExp.txtRem.value := iif(nRec > 0, aData[nRec, 4], '')
Return



static Procedure DeleteRec
	local mRefrec
	if mRecCount = 0
		return
	endif
	if len(Sqlite_query(db, "select * from tran where expid = "+str(aData[mRecPtr, 1])+";")) > 0
		msginfo("Cannot Delete: Reference exists in Transaction!", thiswindow.title)
		return
	endif
	
   If MsgYesNo ( 'Are you sure?',thiswindow.title)
   	if MiscSql(db, "delete from exp where expid = "+str(aData[mRecPtr, 1])+";")
   		ReQuery()
   		RecSkip(1)
   	endif
   EndIf
   Return