#include "dbstruct.ch"
#include "minigui.ch"
#include "common.ch"
#include "hbsqlit3.ch"


Procedure Main
   private  WinMain
   Private Db := Nil
   
	Db := sqlite3_open( "data.db", .t. )
	if empty(db)
		msgbox("Can't Create/Open Data.db")
		return
	endif   

   Set_prog()
	SET HELPFILE TO 'MyExpenseSql.hlp'
   
   DEFINE WINDOW WinMain ;
      AT 0,0 ;
      WIDTH 640 ;
      HEIGHT 460 ;
      TITLE "My Expense SQL" ;
      ICON "LogoIcon" ;
      MAIN   ;
      backcolor {0, 128, 192};
      on init Start_prog()

      @ 23, 27 LABEL lbl_1 VALUE "My Expense SQL: An Expense Management Software for You" AUTOSIZE ;
         FONT "Verdana" SIZE 18 BOLD ITALIC ;
         FONTCOLOR BLACK TRANSPARENT
      @ 20, 24 LABEL lbl_2 VALUE "My Expense SQL: An Expense Management Software for You" AUTOSIZE ;
         FONT "Verdana" SIZE 18 BOLD ITALIC ;
         FONTCOLOR { 151, 223, 255 } TRANSPARENT

      @ 100, 24 LABEL lbl_5 ;
         VALUE "Developed by: Sudip Bhatttacharyya" AUTOSIZE ;
         FONT "Tahoma" SIZE 10 ;//ITALIC ;
         FONTCOLOR { 151, 223, 255 } TRANSPARENT
      @ 120, 24 LABEL lbl_6 ;
         VALUE "Email:" AUTOSIZE ;
         FONT "Tahoma" SIZE 10 ;//ITALIC ;
         FONTCOLOR { 151, 223, 255 } TRANSPARENT
      @ 120, 65 hyperlink email ;
         value "sudipb001@gmail.com" ;
         width 200 ;
         FONT "Tahoma" SIZE 10 ;//ITALIC ;
         FONTCOLOR { 151, 223, 255 } TRANSPARENT HANDCURSOR ;
         address "sudipb001@gmail.com"
         
      @ 150, 24 LABEL lbl_7 ;
         VALUE "Created with HMG, by Roberto Lopez. Database: SQLite" AUTOSIZE ;
         FONT "Tahoma" SIZE 10 ;//ITALIC ;
         FONTCOLOR { 151, 223, 255 } TRANSPARENT
      
         
      @ 170, 24 LABEL lbl_8 ;
         VALUE "Created with help from S. Rathinagiri" AUTOSIZE ;
         FONT "Tahoma" SIZE 10 ;//ITALIC ;
         FONTCOLOR { 151, 223, 255 } TRANSPARENT
         
      @ 200, 24 LABEL lbl_9 ;
         VALUE "Ver 0.8.0" AUTOSIZE ;
         FONT "Tahoma" SIZE 10 ;//ITALIC ;
         FONTCOLOR { 151, 223, 255 } TRANSPARENT

         
      DEFINE MAIN MENU

         DEFINE POPUP "&File"
            MENUITEM "E&xit"           action Exit_Prog()
         END POPUP
         define popup "&Entry"
            menuitem "&Expense Head Setup" action ExpMst()
            menuitem "&Daily Expense Entry" action TranEntry()
         end popup
         define popup "&Report"
         	menuitem "&Expense Report" action TranPrint()
         end popup
         define popup "&Tools"
         	menuitem "Backup Database" action BackupData()
         	//menuitem "Restore Database" action RestoreData()
         	SEPARATOR
         	menuitem "Pack &Database" action PackData()
         end popup
 	      popup "&Help"
    	      ITEM ' &Help ' + Chr(9) + 'F1' ;
                ACTION HELP()
 	      end popup
         
      END MENU
     

   END WINDOW
   ON KEY F1 of winMain ACTION HELP()
   
   // center window winMain
   Maximize window winMain
   ACTIVATE WINDOW WinMain

return


Function Set_prog()
   set talk off
   set dele on
   set date brit
   set cent on
   set epoch to 1950
   SET BROWSESYNC ON
   SET NAVIGATION EXTENDED
   REQUEST DBFCDX , DBFFPT
   RDDSETDEFAULT( "DBFCDX" )
return nil


function Help(mHlpId)
	default mHlpId to 9999
	mHlpId = ltrim(str(mHlpId))
   DISPLAY HELP CONTEXT &mHlpId
return nil


Function Setup_tables()
//   s_ids()
   s_exp()
   s_tran()
return nil


Function Start_prog()
   Setup_Tables()
return nil

Function Exit_prog()
   release window winmain
   close all
return nil


//----------------------------------------- exp.dbf
function s_exp()
	local aRec, i, sQry
	MiscSql(Db, "CREATE TABLE IF NOT EXISTS exp"+ ;
         " ( Expid INTEGER PRIMARY KEY, Expnm TEXT UNIQUE COLLATE NOCASE, Amt REAL default 0.0, Rem TEXT);")       
         
   if file("exp.dbf")
   	wait window "Transferring Expense From Exp.dbf..." nowait
   	if select("exp") = 0
   		use exp new
   	endif
   	select exp
   	go top
   	aRec := {}
   	dbeval({|| aadd(aRec, {alltrim(expid), alltrim(expnm), alltrim(str(amt, 10, 2)), alltrim(rem)})})
   	sQry := "BEGIN TRANSACTION; "
   	for i = 1 to len(aRec)
   		sQry += "INSERT INTO EXP (EXPID, EXPNM, AMT, REM) VALUES ("+aRec[i, 1]+;
   			", '"+aRec[i, 2]+"', "+aRec[i, 3]+", '"+aRec[i, 4]+"'); "
   	next
   	wait clear
   	select exp
   	use
   	sQry += "COMMIT;"
   	if MiscSql(db, sQry)
   		filedelete("exp.dbf")
   		filedelete("exp.cdx")
   	endif
   endif
   return nil


//----------------------------------------- tran.dbf
function s_tran()
	local aRec, i, sQry
	MiscSql(Db, "CREATE TABLE IF NOT EXISTS TRAN"+ ;
         " ( TRANID INTEGER PRIMARY KEY, TRANDT TEXT(8), EXPID INTEGER NOT NULL, "+ ;
         " AMT REAL DEFAULT 0.00, PMTBY TEXT(10), CHQNO TEXT(10), CHQDT TEXT(8), "+ ;
         " CARDNO TEXT(20), BANKNM TEXT, REM TEXT);")
         
   if file("tran.dbf")
   	wait window "Transferring Transactions From Tran.dbf..." nowait
   	if select("Tran") = 0
   		use Tran new
   	endif
   	select Tran
   	go top
   	aRec := {}
   	dbeval({|| aadd(aRec, {alltrim(Tranid), dtos(Trandt), alltrim(Expid), ltrim(str(amt, 10, 2)), alltrim(pmtby), alltrim(chqno), dtos(chqdt), alltrim(cardno), alltrim(banknm), alltrim(rem)})})
   		
   	sQry := "BEGIN TRANSACTION; "
   	for i = 1 to len(aRec)
   		sQry += "INSERT INTO Tran (TranID, TRANDT, EXPID, AMT, PMTBY, CHQNO, CHQDT, CARDNO, BANKNM, REM) " + ;
   			" VALUES ("+aRec[i, 1]+", '"+aRec[i, 2]+"', "+aRec[i, 3]+", "+aRec[i, 4]+", '"+aRec[i, 5]+"', '"+aRec[i, 6]+"', '"+aRec[i, 7]+"', '"+aRec[i, 8]+"', '"+aRec[i, 9]+"', '"+aRec[i, 10]+"');"
   	next
   	wait clear
   	select Tran
   	use
   	sQry += "COMMIT;"
   	if MiscSql(db, sQry)
   		filedelete("Tran.dbf")
   		filedelete("Tran.cdx")
   	endif
   endif

return nil






Function MiscSql(mDb, mStr)
	local cError, n
	n := sqlite3_exec(mDb, mStr)
	if n == 0
		return .t.
	endif
	cError := sqlite3_errmsg(mDb)
	if !empty(cError)
		msgbox(cError)
	endif
	return .f.

*-------------------------------------
 FUNCTION SQLITE_TABLEEXISTS( cTable )
*---------------------------------------------------------------------------
* Uses a (special) master table where the names of all tables are stored
*---------------------------------------------------------------------------
  LOCAL cStatement, lRet := .f.
  LOCAL lCreateIfNotExist := .f.
  LOCAL db := sqlite3_open( "test.db", lCreateIfNotExist )

  cStatement := "SELECT name FROM sqlite_master "    +;
                "WHERE type ='table' AND tbl_name='" +;
                cTable + "'"

  IF DB_IS_OPEN( db )
    lRet := ( LEN( SQLITE_QUERY( db, cStatement ) ) > 0 )
  ENDIF

RETURN( lRet )


*---------------------------------
 FUNCTION SQLITE_FIELDS( cTable )
*---------------------------------------------------------------------------
* Returns an unidimensional array with field names only
*---------------------------------------------------------------------------
  LOCAL aFields := {}, cStatement := "SELECT * FROM " + cTable
  LOCAL lCreateIfNotExist := .f.
  LOCAL db := sqlite3_open( "test.db", lCreateIfNotExist )
  LOCAL stmt, nCCount, nI

  stmt := sqlite3_prepare( db, cStatement )

  sqlite3_step( stmt )
  nCCount := sqlite3_column_count( stmt )  

  IF nCCount > 0
	FOR nI := 1 TO nCCount
	        AADD( aFields, sqlite3_column_name( stmt, nI ) )
	NEXT nI
  ENDIF

  sqlite3_finalize( stmt )

RETURN( aFields )

*--------------------------------
 FUNCTION SQLITE_COLUMNS( cTable )
*---------------------------------------------------------------------------
* Returns an 2-dimensional array with field names and types
*---------------------------------------------------------------------------
  LOCAL aCType :=  { "SQLITE_INTEGER", "SQLITE_FLOAT", "SQLITE_TEXT", "SQLITE_BLOB", "SQLITE_NULL" }
  LOCAL aFields := {}, cStatement := "SELECT * FROM " + cTable
  LOCAL stmt, nCCount, nI, nCType

  stmt := sqlite3_prepare( db, cStatement )

  sqlite3_step( stmt )
  nCCount := sqlite3_column_count( stmt )  

  IF nCCount > 0
	FOR nI := 1 TO nCCount
		nCType := sqlite3_column_type( stmt, nI )
	        AADD( aFields, { sqlite3_column_name( stmt, nI ), aCType[ nCType ] } )
	NEXT nI
  ENDIF

  sqlite3_finalize( stmt )

RETURN( aFields )

*------------------------
 FUNCTION SQLITE_TABLES()
*---------------------------------------------------------------------------
* Uses a (special) master table where the names of all tables are stored
* Returns an array with names of tables inside of the database
*---------------------------------------------------------------------------
  LOCAL aTables, cStatement

  cStatement := "SELECT name FROM sqlite_master "      +;
                "WHERE type IN ('table','view') "      +;
                "AND name NOT LIKE 'sqlite_%' "        +;
                "UNION ALL "                           +;
                "SELECT name FROM sqlite_temp_master " +;
                "WHERE type IN ('table','view') "      +;
                "ORDER BY 1;"

  IF DB_IS_OPEN( db )
    aTables := SQLITE_QUERY( db, cStatement )
  ENDIF

RETURN( aTables )


*--------------------------------------
 FUNCTION SQLITE_QUERY( db, cStatement )
*---------------------------------------------------------------------------
  LOCAL stmt, nCCount, nI, nCType
  LOCAL aRet := {}, aRec := {}

  stmt := sqlite3_prepare( db, cStatement )
                
  IF STMT_IS_PREPARED( stmt )
    DO WHILE sqlite3_step( stmt ) == SQLITE_ROW
    	aRec := {}
	nCCount := sqlite3_column_count( stmt )  

	IF nCCount > 0
		FOR nI := 1 TO nCCount
			nCType := sqlite3_column_type( stmt, nI )

			SWITCH nCType
				CASE SQLITE_NULL
				        AADD( aRec, "NULL")
					EXIT
		
				CASE SQLITE_FLOAT
						AADD(aRec, sqlite3_column_double(stmt, nI))
						exit
				CASE SQLITE_INTEGER
				      //  AADD( aRec, LTRIM(STR( sqlite3_column_int( stmt, nI ) )) )
 						AADD(aRec, sqlite3_column_int(stmt, nI))

					EXIT

				CASE SQLITE_TEXT
			        	AADD( aRec, sqlite3_column_text( stmt, nI ) )
					EXIT
			END SWITCH
		NEXT nI
	ENDIF
		aadd(aRet, aRec)
    ENDDO
    sqlite3_finalize( stmt )
  ENDIF
  
RETURN( aRet )




Function Packdata()
   IF !Empty( db )
      IF sqlite3_exec( db, "VACUUM" ) == SQLITE_OK
      	msgbox("Packing Database Done")
      ELSE
      	msgbox("Can't Pack Database!!!")
      ENDIF
   ENDIF
   return nil