#include 'minigui.ch'
#include 'hbsqlit3.ch'
#include 'common.ch'



static mRecCount := 0, mRecPtr := 0

PROCEDURE TranEntry
   private lAddmode := .f., aExpid := {}, aExpnm := {}, aAmt := {}, ;
   	aPmtBy := {'UNPAID', 'CASH', 'CHEQUE/DD', 'CARD', 'OTHERS'}, aWAExp := {}, aWATran := {}, aData := {}, aGrid := {}

   if isWindowDefined(frmTran)
      return nil
   endif
   
   DEFINE WINDOW frmTran            ;
      AT 0,0               ;
      WIDTH 735            ;
      HEIGHT 560            ;
      TITLE 'Daily Expense'   ;
      CHILD ;
      FONT 'ARIAL' SIZE 9         ;
      ON INIT   (ReQuery(), DeactivateEdit(), RefreshData() ) 

      DEFINE TOOLBAR ToolBar_1 BUTTONSIZE 50,30 FLAT RIGHTTEXT BORDER

      BUTTON btnFirst       ;
         CAPTION '&Top' ;
         picture "HP_TOP" ;
         ACTION GoTop()

      BUTTON btnPrev    ;
         CAPTION '&Prev'    ;
         PICTURE "HP_BACK" ;
         ACTION RecSkip(-1)

      BUTTON btnNext   ;
         CAPTION '&Next'    ;
         PICTURE "HP_NEXT" ;
         ACTION RecSkip(1)
         
      BUTTON btnLast       ;
         CAPTION '&Last'    ;
         PICTURE "HP_END" ;
         ACTION GoBottom()

      BUTTON btnAdd       ;
         CAPTION '&Add'    ;
         PICTURE "MINIGUI_EDIT_ADD" ;
         ACTION (lAddMode := .T., AddRec())

      BUTTON btnModify       ;
         CAPTION '&Modify'    ;
         PICTURE "MINIGUI_EDIT_EDIT" ;
         ACTION ActivateEdit()

      BUTTON btnDelete    ;
         CAPTION '&Delete'   ;
         PICTURE "MINIGUI_EDIT_DELETE" ;
         ACTION DeleteRec()
         
     BUTTON btnPrint    ;
         CAPTION '&Print'   ;
         PICTURE "MINIGUI_EDIT_PRINT" ;
         ACTION TranPrint()

         
      END TOOLBAR
      
      @ 56, 10 label lblSearch ;
      	value "Search:"

      @ 56, 60 DATEPICKER dpkSearch ;
         height 24 ;
         on change SearchData()
         

      @ 86,10 Grid Grid_1            ;
         WIDTH 290              ;
         HEIGHT 430             ;
         HEADERS { 'Date', 'Head', 'Amount' }   ;
         WIDTHS { 75, 100, 75 }         ;
         ITEMS aGrid ;
         JUSTIFY {0, 0, 1} ;
         ON CHANGE {|| mRecPtr := frmTran.grid_1.value, RefreshData(mRecptr)} ;
         ON DBLCLICK ActivateEdit()


      @ 56,310 FRAME FRAME_1 ;
         WIDTH 400      ;
         HEIGHT 460


      @ 66 , 320 LABEL lblTrandt ;
         VALUE 'Date:' ;
         WIDTH 80
      @ 66 , 390 DATEPICKER dpkTrandt
      
      @ 96, 320 LABEL lblExpid ;
      	 VALUE "Head:"
      	 width 80
      @	96, 390 COMBOBOX cboExpid ;
      	width 300 ;
      	items aExpnm ;
      	on change SetAmt()
      	
      @ 126, 320 LABEL lblAmt;
      	VALUE "Amount:"
      @ 126, 390 TEXTBOX txtAmt ;
          NUMERIC INPUTMASK "999,999,999.99" 
          
	  @ 156, 320 label lblPmtby ;
	  	value "Pmt By:"
	  @ 156, 390 combobox cboPmtBy ;
	  	width 100 ;
	  	items aPmtBy
	  	
	  @ 186, 320 label lblChqno ;
	  	value "Chq/DD No.:"
	  @ 186, 390 textbox txtChqno ;
	  	maxlength 10
	  	
	  @ 216, 320 label lblChqdt ;
	  	value "Chq/DD Dt.:"
	  @ 216, 390 datepicker dpkChqdt shownone
	  
	  @ 246, 320 label lblBanknm ;
	  	value "Bank:" 
	  @ 246, 390 text txtBanknm ;
	  	width 300 ;
	  	maxlength 40
	  
	  @ 276, 320 label lblCardno ;
	  	value "Card No.:"
	  @ 276, 390 text txtCardno ;
	  	width 200 ;
	  	maxlength 20
	  	
	  @ 306, 320 label lblRem ;
	  	value "Remarks:"
	  @ 306, 390 editbox edtRem ;
	  	width 200 ;
	  	height 90 ;
	  	maxlength 80

      @ 476,420 BUTTON cmdSave ;
         CAPTION '&Save' ;
         PICTURE "MINIGUI_EDIT_OK" LEFT ;
         ACTION SaveRec()

      @ 476,525 BUTTON cmdCancel ;
         CAPTION '&Cancel' ;
         PICTURE "MINIGUI_EDIT_CANCEL"  LEFT ;
         ACTION CancelRec()

   END WINDOW
   ON KEY F1 of frmTran ACTION HELP(5)

   frmTran.Grid_1.SetFocus
   CENTER WINDOW frmTran
   ACTIVATE WINDOW frmTran

   RETURN


Static Function ReQuery()
	local aExp := {}
	aExpid := {}; aExpnm := {}; aData := {}; aGrid := {}
	aExp := sqlite_query(db, "select expid, expnm, amt from exp order by expnm;")
	aeval(aExp, {|x| aadd(aExpid, x[1]), aadd(aExpnm, x[2]), aadd(aAmt, x[3])})
	aData := sqlite_query(db, "select tranid, trandt, expid, amt, pmtby, chqno, chqdt, banknm, cardno, rem from tran order by trandt, tranid;")
	aGrid := sqlite_query(db, "select trandt, exp.expnm, tran.amt from exp, tran where tran.expid = exp.expid order by trandt, tranid")
	aeval(aData, {|x| x[2] := stod(x[2]), x[7] := stod(x[7])})
	aeval(aGrid, {|x| x[1] := dtoc(stod(x[1])), x[3] := str(x[3], 12, 2)})
	frmTran.grid_1.deleteallitems()
	aeval(aGrid, {|x| frmTran.grid_1.additem(x)})
   frmTran.cboExpid.deleteallitems()
   aeval(aExpnm, {|x| frmTran.cboExpid.additem(x)})
   mRecCount := len(aData)
	if mRecPtr = 0 .and. mRecCount > 0
		mRecPtr := 1
		frmTran.grid_1.value := mRecPtr
	endif
   return nil
   
   
   
static function GoTop()
	if mRecCount = 0
		return nil
	endif
	mRecPtr := 1
	frmTran.grid_1.value := mRecPtr
	return nil
	
	

static function RecSkip(n)
	if mRecCount = 0
		return nil
	endif
	if mRecPtr+n >= 1 .and. mRecPtr+n <= mRecCount
		mRecPtr += n
	else
		mRecPtr := if(n > 0, mRecCount, 1)
	endif
	frmTran.grid_1.value := mRecPtr
	return nil
		

static function GoBottom()
	if mRecCount = 0
		return nil
	endif
	mRecPtr := mRecCount
	frmTran.grid_1.value := mRecPtr
	return nil
   

static function SearchData()
	local d, tmp
	d := frmTran.dpkSearch.value
	tmp := ascan(adata, {|x| x[2] == d})
	if tmp > 0
		frmTran.Grid_1.value := tmp
	endif
	return nil
	
	
      
   
static function SetAmt()
	local temp := 0.00
	if frmTran.cboExpid.value = 0
		return nil
	endif
	temp := aAmt[frmTran.cboExpid.value]
	if temp <> 0.00
		frmTran.txtAmt.value := temp
	endif
	return nil
	   


static PROCEDURE DeactivateEdit
   frmTran.Grid_1.Enabled  := .T.
   frmTran.dpkSearch.Enabled := .t.
   frmTran.dpkTrandt.enabled := .f.
   frmTran.cboExpid.enabled := .f.
   frmTran.txtAmt.enabled := .f.
   frmTran.cboPmtby.enabled := .f.
   frmTran.txtChqno.enabled := .f.
   frmTran.dpkChqdt.enabled := .f.
   frmTran.txtBanknm.enabled := .f.
   frmTran.txtCardno.enabled := .f.
   frmTran.edtRem.enabled := .f.
   
   frmTran.cmdSave.Enabled      := .F.
   frmTran.cmdCancel.Enabled      := .F.
   frmTran.ToolBar_1.Enabled      := .T.
   frmTran.Grid_1.SetFocus
   RETURN


static PROCEDURE ActivateEdit
   frmTran.Grid_1.Enabled  := .f.
   frmTran.dpkSearch.Enabled := .f.
   frmTran.dpkTrandt.enabled := .t.
   frmTran.cboExpid.enabled := .t.
   frmTran.txtAmt.enabled := .t.
   frmTran.cboPmtby.enabled := .t.
   frmTran.txtChqno.enabled := .t.
   frmTran.dpkChqdt.enabled := .t.
   frmTran.txtBanknm.enabled := .t.
   frmTran.txtCardno.enabled := .t.
   frmTran.edtRem.enabled := .t.

   frmTran.cmdSave.Enabled      := .t.
   frmTran.cmdCancel.Enabled      := .t.
   frmTran.ToolBar_1.Enabled      := .f.
   frmTran.dpkTrandt.SetFocus
   RETURN


static PROCEDURE CancelRec()
   DeactivateEdit()
   RefreshData()
   lAddmode := .f.
   RETURN


static PROCEDURE SaveRec()
	local mTranid, mTrandt, mExpid, mAmt, mPmtby, mChqno, mChqdt, mBanknm, mCardno, mRem	

   if empty(frmTran.dpkTrandt.value)
      msgbox("Date cannot be blank!", thiswindow.title); frmTran.dpkTrandt.setfocus(); return
   endif
   
   if empty(frmTran.cboExpid.value)
      msgbox("Please specify expense head", thiswindow.title); frmTran.cboExpid.setfocus(); return
   endif
   
   if empty(frmTran.cboPmtby.value)
      msgbox("Please specify payment by", thiswindow.title); frmTran.cboPmtby.setfocus(); return
   endif
   
   mTrandt := dtos(frmTran.dpkTrandt.value)
   mExpid := aExpid[frmTran.cboExpid.value]
   mAmt := frmTran.txtAmt.value
   mPmtby := aPmtby[frmTran.cboPmtby.value]
   mChqno := frmTran.txtChqno.value
   mChqdt := dtos(frmTran.dpkChqdt.value)
   mBanknm := frmTran.txtBanknm.value
   mCardno := frmTran.txtCardno.value
   mRem := frmTran.edtRem.value
   
   If lAddmode
   	if !miscsql(db, "INSERT INTO TRAN (TRANID, TRANDT, EXPID, AMT, PMTBY, CHQNO, CHQDT, BANKNM, CARDNO, REM) VALUES " + ;
   		" (NULL, '"+mTrandt+"', "+str(mExpid)+", "+str(mAmt, 12, 2)+", '"+mPmtby+"', '"+mChqno+"', '"+;
   		mChqdt+"', '"+mBanknm+"', '"+mCardno+"', '"+mRem+"');")
   		return
   	endif
   	lAddmode = .f.
   else
		mTranid := aData[mRecPtr, 1]   
   	if !miscsql(db, "UPDATE TRAN SET "+ ;
   		" trandt	= '"+mTrandt			+"', " + ;
   		" expid 	= "+str(mExpid)		+", " + ;
   		" amt 	= "+str(mAmt, 12, 2)	+", " + ;
   		" pmtby 	= '"+mPmtby				+"', " + ;
   		" chqno 	= '"+mChqno				+"', " + ;
   		" chqdt 	= '"+mChqdt				+"', " + ;
   		" banknm = '"+mBanknm			+"', " + ;
   		" rem 	= '"+mRem				+"' " + ;
   		" WHERE TranID = "+STR(mTranid)+";")
   		Return
   	endif
   endif
   Requery()
   mRecPtr = ascan(aData, {|x| x[2] == stod(mTrandt)})
   frmTran.grid_1.value := mRecPtr
   DeactivateEdit()
   RETURN
   


static PROCEDURE AddRec()
	RefreshData(0)
   ActivateEdit()
   RETURN


static PROCEDURE RefreshData(nRec)
	default nRec to mRecPtr
   frmTran.dpkTrandt.value := if(nRec > 0, aData[nRec, 2], ctod(''))
   frmTran.cboExpid.value := if(nRec > 0, ascan(aExpid, aData[nRec, 3]), 0)
   frmTran.txtAmt.value := if(nRec > 0, aData[nRec, 4], 0.00)
   frmTran.cboPmtby.value := if(nRec > 0, ascan(aPmtby, aData[nRec, 5]), 0)
   frmTran.txtChqno.value := if(nRec > 0, aData[nRec, 6], '')
   frmTran.dpkChqdt.value := if(nRec > 0, aData[nRec, 7], ctod(''))
   frmTran.txtBanknm.value := if(nRec > 0, aData[nRec, 8], '')
   frmTran.txtCardno.value := if(nRec > 0, aData[nRec, 9], '')
   frmTran.edtRem.value := if(nRec> 0, aData[nRec, 10], '')
	Return



static Procedure DeleteRec
   If MsgYesNo ( 'Are you sure?')
   	if MiscSql(db, "delete from tran where tranid = "+str(aData[mRecPtr, 1])+";")
   		ReQuery()
   		RecSkip(1)
   	endif
   EndIf
   Return