#include <minigui.ch>
#include <hfcl.ch>

Function TranPrint()
	PRIVATE mTranRec := 0, aRows := {}, aSum, aExpid := {}, aExpnm := {}, mOldRel, aExp := {}
	
	aSum := {{.f.,""},{.f.,""},{.t.,"999,999,999.99"}, {.f.,""}, {.f.,""}}
	
	aExp := sqlite_query(db, "select expid, expnm, amt, rem from exp order by expnm;")
   aeval(aExp, {|x| aadd(aExpid, x[1]), aadd(aExpnm, x[2])})
   
   DEFINE WINDOW frmTranPrint            ;
      AT 0,0               ;
      WIDTH 790            ;
      HEIGHT 590            ;
      TITLE 'Expense Report'   ;
      MODAL
      
      @ 10, 10 label lblFromdt value "From:"
      @ 10, 50 datepicker dpkFromdt value bom(date())
      
      @ 10, 200 label lblTodt value "To:"
      @ 10, 230 datepicker dpkTodt value eom(date())
     
      @ 10, 670 button cmdRun caption "&Run" ;
      	action CreateGrid()
      	
		@ 40, 10 label lblExpid value "Select head:" autosize
      @ 40, 80 COMBOBOX cboExpid ;
      	width 300 ;
      	items aExpnm ;
      	value 0 
		@ 40, 400 checkbox chkAllexp caption "All expense heads" ;
			width 200 value .t. ;
			on change {|| frmTranPrint.cboExpid.value := iif(this.value, 0, frmTranPrint.cboExpid.value), ;
				frmTranPrint.cboExpid.enabled := !frmTranPrint.chkAllExp.value} 
				
		@ 70,10 RADIOGROUP radRptType ;
			OPTIONS { 'All' , 'Paid Only' , 'Unpaid Only'} ;
			VALUE 1 ;
			WIDTH 75 ;
			HORIZONTAL
				
      
		@ 100,10 GRID Grid_1 ;
			WIDTH 650 ;
			HEIGHT 400 ;
			HEADERS {'Date','Head','Amount','Pmt by', 'Others'} ;
			WIDTHS {100,200,100,100,200} ;
			JUSTIFY {0,0,1,0,0};
			ITEMS aRows ;
			VALUE 1 
			
      @ 480, 670 button cmdPrint caption "&Print" ;
      	action DoPrint()
      
      @ 520, 450 label lblTotal value "Total:"
      @ 520, 500 textbox txtTotamt ;
      	readonly value 0.00 numeric inputmask "9999999.99"
      
   END WINDOW
   ON KEY F1 of frmTranPrint ACTION HELP(7)
   frmTranPrint.cboExpid.enabled := .f.
   frmTranPrint.center
   frmTranPrint.activate
	return NIL
	

static function CreateGrid()
	local mFromdt := frmTranPrint.dpkFromdt.value, mTodt := frmTranPrint.dpkTodt.value, ;
		mTotamt := 0.00, mExpid := '', mRptType := frmTranPrint.radRptType.value, aTemp := {}
	
	if frmTranPrint.cboExpid.value != 0
		mExpid := aExpid[frmTranPrint.cboExpid.value]
	endif
	
	aRows := {}
	sQry := "SELECT TRANDT, EXP.EXPNM, TRAN.AMT, TRAN.PMTBY, CHQNO, CHQDT, BANKNM, CARDNO FROM TRAN, EXP WHERE TRAN.EXPID = EXP.EXPID "
	
	if !empty(mExpid)
		sQry += " AND EXPID = "+STR(MEXPID)
	ENDIF
	
	DO CASE
		CASE MRPTTYPE = 2
			SQRY += " AND NOT PMTBY = 'UNPAID'"
		CASE MRPTTYPE = 3
			SQRY += " AND PMTBY = 'UNPAID'"
	ENDCASE
	
	SQRY += " ORDER BY TRANDT;"
	
	aTemp := sqlite_query(db, sQry)
	
	aRows := {}
	aeval(aTemp, {|x| aadd(aRows, {dtoc(stod(x[1])), x[2], str(x[3], 12, 2), x[4], getothers(x[5], stod(x[6]), x[7], x[8])})})
	frmTranPrint.grid_1.deleteallitems()
	aEval(aRows, {|x| frmTranPrint.grid_1.additem(x)})
	frmTranPrint.txtTotamt.value := mTotamt
	return nil
	
	
static function GetOthers(mChqno, mChqdt, mBanknm, mCardno)
	local mesg := ""
	if !empty(mchqno)
		mesg += iif(empty(mesg), "", ", ")+"Chq/DD No.: "+alltrim(mchqno)
	endif	
	if !empty(mchqdt)
		mesg += iif(empty(mesg), "", ", ")+"Chq/DD Dt.: "+dtoc(mchqdt)
	endif	
	if !empty(mbanknm)
		mesg += iif(empty(mesg), "", ", ")+"Bank: "+alltrim(mbanknm)
	endif	
	if !empty(mcardno)
		mesg += iif(empty(mesg), "", ", ")+"Card No.: "+alltrim(mcardno)
	endif
	return mesg
	
	
	
static function DoPrint()
	local mFromdt := frmTranPrint.dpkFromdt.value, mTodt := frmTranPrint.dpkTodt.value, ;
		strHead2, strHead3
	
	strHead2 := "("+dtoc(mFromdt)+" to "+dtoc(mTodt)+")"
	strHead3 := ""
	do case
		case frmTranPrint.radRptType.value = 2
			strHead3 := " for Paid Expenses"
		case frmTranPrint.radRptType.value = 3
			strHead3 := " for Unpaid Expenses"
	endcase
	PRINT GRID grid_1 OF frmTranPrint FONT "Arial" SIZE 12 ORIENTATION "P" ;
		HEADERS {"Expense Report"+strHead3, strHead2} COLUMNSUM aSum SHOWWINDOW

	return nil	